#!/usr/bin/perl

use Math::Trig;
my $PI = pi();

#input parameters
#make X-axis for INT
############################################################

$G_probe = 0.0535;	#G/m*A
$I_max = 10;		#max current A
$scale = 0.90;		#smoothed square 10% integral
#$scale = 1.00;		#Square integral
#$scale = 0.63 ;        #Sine lobe integral

$G_max = $G_probe*$I_max*$scale;		#max gradient G/m;

$p_low = 5;		#G pulse low percent
$p_high = 95;		#G pulse high percent
$steps = 16;		#number of gradient steps

############################################################

$g_step = ($p_high - $p_low)/($steps-1);	#calc gradient inc

#print applied grad pulses
for($i = 1; $i <= $steps; $i = $i + 1){
   $gp =  ($p_low + ($i-1)*$g_step)/100;		#current applied gradient
   $g = $gp*$G_max;
   printf"%3.4f ",$g;		#applied gradient 
}
   printf"\n";		

